Index: /palm/trunk/SOURCE/data_output_binary_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_binary_module.f90	(revision 4628)
+++ /palm/trunk/SOURCE/data_output_binary_module.f90	(revision 4629)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+!
+! 4597 2020-07-09 19:21:53Z gronemeier
 ! change: update argument list of routine binary_init_dimension due to changes in interface
 !
@@ -62,5 +65,5 @@
     USE kinds
 
-#if defined( __parallel ) && !defined( __mpifh )
+#if defined( __parallel )
     USE MPI
 #endif
@@ -68,7 +71,4 @@
     IMPLICIT NONE
 
-#if defined( __parallel ) && defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
 
     CHARACTER(LEN=*), PARAMETER ::  config_file_name = 'BINARY_TO_NETCDF_CONFIG'  !< name of config file
Index: /palm/trunk/SOURCE/data_output_netcdf4_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4628)
+++ /palm/trunk/SOURCE/data_output_netcdf4_module.f90	(revision 4629)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+!
+! 4599 2020-07-10 12:42:02Z gronemeier
 ! bugfix: set no-fill mode per variable
 !
@@ -70,5 +73,5 @@
     USE kinds
 
-#if defined( __parallel ) && !defined( __mpifh )
+#if defined( __parallel )
     USE MPI
 #endif
@@ -80,7 +83,4 @@
     IMPLICIT NONE
 
-#if defined( __parallel ) && defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
 
     CHARACTER(LEN=*), PARAMETER ::  mode_parallel = 'parallel'  !< string selecting netcdf4 parallel mode
Index: /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4629)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+!
+! 4628 2020-07-29 07:23:03Z raasch
 ! extensions required for MPI-I/O of particle data to restart files
 !
@@ -270,5 +273,5 @@
 !        ONLY:  dop_active, dop_init, dop_output_tseries
 
-#if defined( __parallel )  &&  !defined( __mpifh )
+#if defined( __parallel )
     USE MPI
 #endif
Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 4628)
+++ /palm/trunk/SOURCE/modules.f90	(revision 4629)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+! 
+! 4581 2020-06-29 08:49:58Z suehring
 ! +sums_wschs_ws_l
 !
@@ -1278,10 +1281,7 @@
 
 #if defined( __parallel )
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#else
     USE MPI
 #endif
-#endif
+
     CHARACTER(LEN=2) ::  send_receive = 'al'     !<
     CHARACTER(LEN=7) ::  myid_char = ''          !< character string containing processor id number
Index: /palm/trunk/SOURCE/pmc_child_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_child_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/pmc_child_mod.f90	(revision 4629)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! 
 ! 
@@ -60,7 +63,5 @@
     USE, INTRINSIC ::  iso_c_binding
 
-#if !defined( __mpifh )
     USE MPI
-#endif
 
     USE kinds
@@ -78,7 +79,4 @@
     IMPLICIT NONE
 
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
 
     PRIVATE
Index: /palm/trunk/SOURCE/pmc_general_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_general_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/pmc_general_mod.f90	(revision 4629)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 !
@@ -50,13 +53,8 @@
     USE kinds
 
-#if !defined( __mpifh )
     USE MPI
-#endif
 
     IMPLICIT NONE
 
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
 
     PRIVATE
Index: /palm/trunk/SOURCE/pmc_handle_communicator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 4629)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -52,7 +55,5 @@
     USE kinds
 
-#if !defined( __mpifh )
     USE MPI
-#endif
 
     USE pmc_general,                                                            &
@@ -63,7 +64,4 @@
     IMPLICIT NONE
 
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
 
     TYPE pmc_layout
Index: /palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 4629)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+! 
+! 4508 2020-04-24 13:32:20Z raasch
 ! salsa variable name changed
 ! 
@@ -257,7 +260,5 @@
 
 #if defined( __parallel )
-#if !defined( __mpifh )
     USE MPI
-#endif
 
     USE pegrid,                                                                &
@@ -301,9 +302,4 @@
     IMPLICIT NONE
 
-#if defined( __parallel )
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
-#endif
 
     PRIVATE
Index: /palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/pmc_mpi_wrapper_mod.f90	(revision 4629)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -43,7 +46,5 @@
     USE, INTRINSIC ::  ISO_C_BINDING
 
-#if !defined( __mpifh )
     USE MPI
-#endif
 
     USE kinds
@@ -53,7 +54,4 @@
     IMPLICIT NONE
 
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
 
     PRIVATE
Index: /palm/trunk/SOURCE/pmc_parent_mod.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_parent_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/pmc_parent_mod.f90	(revision 4629)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! 
 ! 
@@ -52,7 +55,6 @@
     USE, INTRINSIC ::  ISO_C_BINDING
 
-#if !defined( __mpifh )
     USE MPI
-#endif
+
     USE kinds
     USE pmc_general,                                                           &
@@ -69,7 +71,4 @@
    IMPLICIT NONE
 
-#if defined( __mpifh )
-   INCLUDE "mpif.h"
-#endif
 
    PRIVATE
Index: /palm/trunk/SOURCE/pmc_particle_interface.f90
===================================================================
--- /palm/trunk/SOURCE/pmc_particle_interface.f90	(revision 4628)
+++ /palm/trunk/SOURCE/pmc_particle_interface.f90	(revision 4629)
@@ -21,9 +21,12 @@
 ! Current revisions:
 ! ------------------
+!
+!
+! Former revisions:
+! -----------------
+! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
 ! 
-! 
-! Former revisions:
-! -----------------! 
-! $Id$
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: preprocessor directives for serial mode added
 ! 
@@ -57,7 +60,5 @@
    USE, INTRINSIC ::  ISO_C_BINDING
 
-#if defined( __parallel )  &&  !defined( __mpifh )
    USE MPI
-#endif
 
    USE kinds
@@ -112,7 +113,4 @@
    IMPLICIT NONE
 
-#if defined( __parallel )  &&  defined( __mpifh )
-   INCLUDE "mpif.h"
-#endif
 
    PRIVATE
Index: /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90
===================================================================
--- /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4629)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+!
+! 4628 2020-07-29 07:23:03Z raasch
 ! extensions required for MPI-I/O of particle data to restart files
 !
@@ -78,9 +81,5 @@
 
 #if defined( __parallel )
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#else
     USE MPI
-#endif
 #else
     USE posix_interface,                                                                           &
Index: /palm/trunk/SOURCE/shared_memory_io_mod.f90
===================================================================
--- /palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/shared_memory_io_mod.f90	(revision 4629)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+!
+! 4628 2020-07-29 07:23:03Z raasch
 ! extensions required for MPI-I/O of particle data to restart files
 !
@@ -53,9 +56,5 @@
 
 #if defined( __parallel )
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#else
     USE MPI
-#endif
 #endif
 
Index: /palm/trunk/SOURCE/spectra_mod.f90
===================================================================
--- /palm/trunk/SOURCE/spectra_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/spectra_mod.f90	(revision 4629)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+!
+! 4591 2020-07-06 15:56:08Z raasch
 ! File re-formatted to follow the PALM coding standard
 !
@@ -546,7 +549,5 @@
 
 #if defined( __parallel )
-#if !defined( __mpifh )
     USE MPI
-#endif
 
     USE pegrid,                                                                                    &
@@ -561,10 +562,4 @@
 
     IMPLICIT NONE
-
-#if defined( __parallel )
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
-#endif
 
     INTEGER(iwp) ::  i   !<
@@ -575,4 +570,5 @@
 
     REAL(wp), DIMENSION(nzb:nzt+1) ::  var_d_l  !<
+
 
     SELECT CASE ( TRIM( data_output_sp(m) ) )
@@ -657,7 +653,5 @@
     USE kinds
 
-#if !defined( __mpifh )
     USE MPI
-#endif
 
     USE pegrid,                                                                                    &
@@ -674,8 +668,4 @@
 
     IMPLICIT NONE
-
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
 
     INTEGER(iwp) ::  i  !<
@@ -801,7 +791,5 @@
     USE kinds
 
-#if !defined( __mpifh )
     USE MPI
-#endif
 
     USE pegrid,                                                                                    &
@@ -818,8 +806,4 @@
 
     IMPLICIT NONE
-
-#if defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
 
     INTEGER(iwp) ::  i  !<
Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4628)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4629)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! support for MPI Fortran77 interface (mpif.h) removed
+!
+! 4603 2020-07-14 16:08:30Z suehring
 ! Bugfix in initialization from ASCII file - x-length scales at the bottom boundary were not
 ! initialized properly
@@ -245,5 +248,5 @@
     USE kinds
 
-#if defined( __parallel )  &&  !defined( __mpifh )
+#if defined( __parallel )
     USE MPI
 #endif
@@ -285,9 +288,4 @@
 
     IMPLICIT NONE
-
-#if defined( __parallel )  &&  defined( __mpifh )
-    INCLUDE "mpif.h"
-#endif
-
 
     INTEGER(iwp) ::  id_stg_left        !< left lateral boundary core id in case of turbulence generator