Index: palm/trunk/SOURCE/init_rankine.f90
===================================================================
--- palm/trunk/SOURCE/init_rankine.f90	(revision 4457)
+++ palm/trunk/SOURCE/init_rankine.f90	(revision 4648)
@@ -1,33 +1,35 @@
 !> @file init_rankine.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4457 2020-03-11 14:20:43Z raasch
 ! use statement for exchange horiz added
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! Modularization of all bulk cloud physics code components
@@ -39,28 +41,28 @@
 ! Description:
 ! ------------
-!> Initialize a (nondivergent) Rankine eddy with a vertical axis in order to test 
-!> the advection terms and the pressure solver.
-!------------------------------------------------------------------------------!
+!> Initialize a (nondivergent) Rankine eddy with a vertical axis in order to test the advection
+!> terms and the pressure solver.
+!--------------------------------------------------------------------------------------------------!
  SUBROUTINE init_rankine
- 
-
-    USE arrays_3d,                                                             &
+
+
+    USE arrays_3d,                                                                                 &
         ONLY:  pt, pt_init, u, u_init, v, v_init
 
-    USE control_parameters,                                                    &
-        ONLY:  initializing_actions, n_sor, nsor, nsor_ini   
-
-    USE basic_constants_and_equations_mod,                                     &
+    USE control_parameters,                                                                        &
+        ONLY:  initializing_actions, n_sor, nsor, nsor_ini
+
+    USE basic_constants_and_equations_mod,                                                         &
         ONLY:  pi
 
-    USE exchange_horiz_mod,                                                    &
+    USE exchange_horiz_mod,                                                                        &
         ONLY:  exchange_horiz
 
-    USE grid_variables,                                                        &
-        ONLY:  dx, dy 
-
-    USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt     
-                
+    USE grid_variables,                                                                            &
+        ONLY:  dx, dy
+
+    USE indices,                                                                                   &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+
     USE kinds
 
@@ -74,5 +76,5 @@
     INTEGER(iwp) ::  kc1 !<
     INTEGER(iwp) ::  kc2 !<
-    
+
     REAL(wp)     ::  alpha  !<
     REAL(wp)     ::  betrag !<