Index: palm/trunk/SOURCE/pmc_handle_communicator_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 4629)
+++ palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 4649)
@@ -1,23 +1,23 @@
 !> @file pmc_handle_communicator_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
-! ------------------
+! -----------------
 !
 !
@@ -25,23 +25,27 @@
 ! -----------------
 ! $Id$
-! support for MPI Fortran77 interface (mpif.h) removed
-! 
+! File re-formatted to follow the PALM coding standard
+!
+!
+! 4629 2020-07-29 09:37:56Z raasch
+! Support for MPI Fortran77 interface (mpif.h) removed
+!
 ! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
-! 
+!
 ! 3888 2019-04-12 09:18:10Z hellstea
 ! Missing MPI_BCAST of anterpolation_buffer_width added.
-! 
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
-! of additional debug messages
-! 
+! Changes related to global restructuring of location messages and introduction of additional debug
+! messages
+!
 ! 3819 2019-03-27 11:01:36Z hellstea
-! Adjustable anterpolation buffer introduced on all nest boundaries, it is controlled
-! by the new nesting_parameters parameter anterpolation_buffer_width.
-! 
+! Adjustable anterpolation buffer introduced on all nest boundaries, it is controlled by the new
+! nesting_parameters parameter anterpolation_buffer_width.
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! nestpar renamed to nesting_parameters
-! 
+!
 ! 1762 2016-02-25 12:31:13Z hellstea
 ! Initial revision by K. Ketelsen
@@ -50,5 +54,5 @@
 ! ------------
 ! Handle MPI communicator in PALM model coupler
-!-------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  MODULE PMC_handle_communicator
 #if defined( __parallel )
@@ -57,7 +61,11 @@
     USE MPI
 
-    USE pmc_general,                                                            &
-        ONLY: pmc_status_ok, pmc_status_error, pmc_max_models
-    USE control_parameters,                                                     &
+    USE pmc_general,                                                                               &
+        ONLY: pmc_max_models,                                                                      &
+              pmc_status_error,                                                                    &
+              pmc_status_ok
+
+
+    USE control_parameters,                                                                        &
         ONLY: message_string
 
@@ -67,9 +75,9 @@
     TYPE pmc_layout
 
-       CHARACTER(LEN=32) ::  name
-
-       INTEGER  ::  id            !<
-       INTEGER  ::  parent_id     !<
-       INTEGER  ::  npe_total     !<
+       CHARACTER(LEN=32) ::  name  !<
+
+       INTEGER ::  id            !<
+       INTEGER ::  npe_total     !<
+       INTEGER ::  parent_id     !<
 
        REAL(wp) ::  lower_left_x  !<
@@ -78,5 +86,5 @@
     END TYPE pmc_layout
 
-    PUBLIC  pmc_status_ok, pmc_status_error
+    PUBLIC  pmc_status_ok, pmc_status_error  !<
 
     INTEGER, PARAMETER, PUBLIC ::  pmc_error_npes        = 1  !< illegal number of processes
@@ -84,23 +92,27 @@
     INTEGER, PARAMETER, PUBLIC ::  pmc_no_namelist_found = 3  !< no couple layout namelist found
 
+    INTEGER ::  m_my_cpl_id   !< coupler id of this model
+    INTEGER ::  m_ncpl        !< number of couplers given in nesting_parameters namelist
+    INTEGER ::  m_parent_id   !< coupler id of parent of this model
     INTEGER ::  m_world_comm  !< global nesting communicator
-    INTEGER ::  m_my_cpl_id   !< coupler id of this model
-    INTEGER ::  m_parent_id   !< coupler id of parent of this model
-    INTEGER ::  m_ncpl        !< number of couplers given in nesting_parameters namelist
 
     TYPE(pmc_layout), PUBLIC, DIMENSION(pmc_max_models) ::  m_couplers  !< information of all couplers
 
     INTEGER, PUBLIC ::  m_model_comm          !< communicator of this model
+    INTEGER, PUBLIC ::  m_model_npes          !<
+    INTEGER, PUBLIC ::  m_model_rank          !<
     INTEGER, PUBLIC ::  m_to_parent_comm      !< communicator to the parent
     INTEGER, PUBLIC ::  m_world_rank          !<
+    INTEGER         ::  m_parent_remote_size  !< number of processes in the parent model
     INTEGER         ::  m_world_npes          !<
-    INTEGER, PUBLIC ::  m_model_rank          !<
-    INTEGER, PUBLIC ::  m_model_npes          !<
-    INTEGER         ::  m_parent_remote_size  !< number of processes in the parent model 
     INTEGER         ::  peer_comm             !< peer_communicator for inter communicators
 
-    INTEGER, DIMENSION(pmc_max_models), PUBLIC ::  m_to_child_comm    !< communicator to the child(ren)
-    INTEGER, DIMENSION(:), POINTER, PUBLIC ::  pmc_parent_for_child   !<
-
+    INTEGER, DIMENSION(pmc_max_models), PUBLIC ::  m_to_child_comm   !< communicator to the child(ren)
+    INTEGER, DIMENSION(:), POINTER, PUBLIC ::  pmc_parent_for_child  !<
+
+
+    INTERFACE pmc_get_model_info
+       MODULE PROCEDURE pmc_get_model_info
+    END INTERFACE pmc_get_model_info
 
     INTERFACE pmc_is_rootmodel
@@ -108,29 +120,33 @@
     END INTERFACE pmc_is_rootmodel
 
-    INTERFACE pmc_get_model_info
-       MODULE PROCEDURE pmc_get_model_info
-    END INTERFACE pmc_get_model_info
-
-    PUBLIC pmc_get_model_info, pmc_init_model, pmc_is_rootmodel
+    PUBLIC pmc_get_model_info, pmc_init_model, pmc_is_rootmodel   !<
+
+
 
  CONTAINS
 
- SUBROUTINE pmc_init_model( comm, nesting_datatransfer_mode, nesting_mode,      &
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @Todo: Missing subroutine description.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE pmc_init_model( comm, nesting_datatransfer_mode, nesting_mode,                         &
                             anterpolation_buffer_width, pmc_status )
 
-    USE control_parameters,                                                     &
+    USE control_parameters,                                                                        &
         ONLY:  message_string
 
-    USE pegrid,                                                                 &
+    USE pegrid,                                                                                    &
         ONLY:  myid
 
       IMPLICIT NONE
 
+    CHARACTER(LEN=7), INTENT(INOUT) ::  nesting_datatransfer_mode  !<
     CHARACTER(LEN=8), INTENT(INOUT) ::  nesting_mode               !<
-    CHARACTER(LEN=7), INTENT(INOUT) ::  nesting_datatransfer_mode  !<
-
-    INTEGER, INTENT(INOUT) ::  anterpolation_buffer_width          !< Boundary buffer width for anterpolation
-    INTEGER, INTENT(INOUT) ::  comm        !<
-    INTEGER, INTENT(INOUT) ::  pmc_status  !<
+
+    INTEGER, INTENT(INOUT) ::  anterpolation_buffer_width  !< Boundary buffer width for anterpolation
+    INTEGER, INTENT(INOUT) ::  comm                        !<
+    INTEGER, INTENT(INOUT) ::  pmc_status                  !<
 
     INTEGER ::  childcount     !<
@@ -141,6 +157,6 @@
     INTEGER ::  tag            !<
 
-    INTEGER, DIMENSION(pmc_max_models)   ::  activeparent  ! I am active parent for this child ID
-    INTEGER, DIMENSION(pmc_max_models+1) ::  start_pe
+    INTEGER, DIMENSION(pmc_max_models)   ::  activeparent  !< I am active parent for this child ID
+    INTEGER, DIMENSION(pmc_max_models+1) ::  start_pe      !<
 
     pmc_status   = pmc_status_ok
@@ -158,9 +174,9 @@
     IF ( m_world_rank == 0 )  THEN
 
-       CALL read_coupling_layout( nesting_datatransfer_mode, nesting_mode,      &
+       CALL read_coupling_layout( nesting_datatransfer_mode, nesting_mode,                         &
                                   anterpolation_buffer_width, pmc_status )
 
-       IF ( pmc_status /= pmc_no_namelist_found  .AND.                          &
-            pmc_status /= pmc_namelist_error )                                  &
+       IF ( pmc_status /= pmc_no_namelist_found  .AND.                                             &
+            pmc_status /= pmc_namelist_error )                                                     &
        THEN
 !
@@ -172,11 +188,11 @@
 
 !
-!--       The sum of numbers of processes requested by all the domains
-!--       must be equal to the total number of processes of the run
+!--       The sum of numbers of processes requested by all the domains must be equal to the total
+!--       number of processes of the run
           IF ( start_pe(m_ncpl+1) /= m_world_npes )  THEN
-             WRITE ( message_string, '(2A,I6,2A,I6,A)' )                        &
-                             'nesting-setup requires different number of ',     &
-                             'MPI procs (', start_pe(m_ncpl+1), ') than ',      &
-                             'provided (', m_world_npes,')'
+             WRITE( message_string, '(2A,I6,2A,I6,A)' )                                            &
+                                                'nesting-setup requires different number of ',     &
+                                                'MPI procs (', start_pe(m_ncpl+1), ') than ',      &
+                                                'provided (', m_world_npes,')'
              CALL message( 'pmc_init_model', 'PA0229', 3, 2, 0, 6, 0 )
           ENDIF
@@ -186,8 +202,7 @@
     ENDIF
 !
-!-- Broadcast the read status. This synchronises all other processes with 
-!-- process 0 of the root model. Without synchronisation, they would not 
-!-- behave in the correct way (e.g. they would not return in case of a
-!-- missing NAMELIST).
+!-- Broadcast the read status. This synchronises all other processes with process 0 of the root
+!-- model. Without synchronisation, they would not behave in the correct way (e.g. they would not
+!-- return in case of a missing NAMELIST).
     CALL MPI_BCAST( pmc_status, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
 
@@ -200,7 +215,7 @@
     ELSEIF ( pmc_status == pmc_namelist_error )  THEN
 !
-!--    Only the root model gives the error message. Others are aborted by the
-!--    message-routine with MPI_ABORT. Must be done this way since myid and
-!--    comm2d have not yet been assigned at this point.
+!--    Only the root model gives the error message. Others are aborted by the message-routine with
+!--    MPI_ABORT. Must be done this way since myid and comm2d have not yet been assigned at this
+!--    point.
        IF ( m_world_rank == 0 )  THEN
           message_string = 'errors in \$nesting_parameters'
@@ -215,28 +230,25 @@
 !-- Broadcast coupling layout
     DO  i = 1, m_ncpl
-       CALL MPI_BCAST( m_couplers(i)%name, LEN( m_couplers(i)%name ),           &
+       CALL MPI_BCAST( m_couplers(i)%name, LEN( m_couplers(i)%name ),                              &
                        MPI_CHARACTER, 0, MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%id,           1, MPI_INTEGER, 0,           &
+       CALL MPI_BCAST( m_couplers(i)%id,           1, MPI_INTEGER, 0,                              &
                        MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%Parent_id,    1, MPI_INTEGER, 0,           &
+       CALL MPI_BCAST( m_couplers(i)%Parent_id,    1, MPI_INTEGER, 0,                              &
                        MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%npe_total,    1, MPI_INTEGER, 0,           &
+       CALL MPI_BCAST( m_couplers(i)%npe_total,    1, MPI_INTEGER, 0,                              &
                        MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%lower_left_x, 1, MPI_REAL,    0,           &
+       CALL MPI_BCAST( m_couplers(i)%lower_left_x, 1, MPI_REAL,    0,                              &
                        MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%lower_left_y, 1, MPI_REAL,    0,           &
+       CALL MPI_BCAST( m_couplers(i)%lower_left_y, 1, MPI_REAL,    0,                              &
                        MPI_COMM_WORLD, istat )
     ENDDO
-    CALL MPI_BCAST( nesting_mode, LEN( nesting_mode ), MPI_CHARACTER, 0,        &
+    CALL MPI_BCAST( nesting_mode, LEN( nesting_mode ), MPI_CHARACTER, 0, MPI_COMM_WORLD, istat )
+    CALL MPI_BCAST( nesting_datatransfer_mode, LEN(nesting_datatransfer_mode), MPI_CHARACTER, 0,   &
                     MPI_COMM_WORLD, istat )
-    CALL MPI_BCAST( nesting_datatransfer_mode, LEN(nesting_datatransfer_mode),  &
-                    MPI_CHARACTER, 0, MPI_COMM_WORLD, istat )
-    CALL MPI_BCAST( anterpolation_buffer_width, 1, MPI_INT, 0, MPI_COMM_WORLD,  &
-                    istat )
+    CALL MPI_BCAST( anterpolation_buffer_width, 1, MPI_INT, 0, MPI_COMM_WORLD, istat )
 !
 !-- Assign global MPI processes to individual models by setting the couple id
     DO  i = 1, m_ncpl
-       IF ( m_world_rank >= start_pe(i)  .AND.  m_world_rank < start_pe(i+1) )  &
-       THEN
+       IF ( m_world_rank >= start_pe(i)  .AND.  m_world_rank < start_pe(i+1) )  THEN
           m_my_cpl_id = i
           EXIT
@@ -245,9 +257,8 @@
     m_my_cpl_rank = m_world_rank - start_pe(i)
 !
-!-- MPI_COMM_WORLD is the communicator for ALL models (MPI-1 approach).
-!-- The communictors for the individual models as created by MPI_COMM_SPLIT.
-!-- The color of the model is represented by the coupler id
-    CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, m_my_cpl_id, m_my_cpl_rank, comm,      &
-                         istat )
+!-- MPI_COMM_WORLD is the communicator for ALL models (MPI-1 approach). The communictors for the
+!-- individual models as created by MPI_COMM_SPLIT. The color of the model is represented by the
+!-- coupler id
+    CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, m_my_cpl_id, m_my_cpl_rank, comm, istat )
 !
 !-- Get size and rank of the model running on this process
@@ -257,8 +268,6 @@
 !-- Broadcast (from process 0) the parent id and id of every model
     DO  i = 1, m_ncpl
-       CALL MPI_BCAST( m_couplers(i)%parent_id, 1, MPI_INTEGER, 0,              &
-                       MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%id,        1, MPI_INTEGER, 0,              &
-                       MPI_COMM_WORLD, istat )
+       CALL MPI_BCAST( m_couplers(i)%parent_id, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
+       CALL MPI_BCAST( m_couplers(i)%id,        1, MPI_INTEGER, 0, MPI_COMM_WORLD, istat )
     ENDDO
 !
@@ -268,35 +277,29 @@
 !
 !-- Create intercommunicator between the parent and children.
-!-- MPI_INTERCOMM_CREATE creates an intercommunicator between 2 groups of
-!-- different colors.
-!-- The grouping was done above with MPI_COMM_SPLIT.
-!-- A duplicate of MPI_COMM_WORLD is created and used as peer communicator 
-!-- (peer_comm) for MPI_INTERCOMM_CREATE.
-    CALL MPI_COMM_DUP( MPI_COMM_WORLD, peer_comm, ierr ) 
+!-- MPI_INTERCOMM_CREATE creates an intercommunicator between 2 groups of different colors. The
+!-- grouping was done above with MPI_COMM_SPLIT. A duplicate of MPI_COMM_WORLD is created and used
+!-- as peer communicator (peer_comm) for MPI_INTERCOMM_CREATE.
+    CALL MPI_COMM_DUP( MPI_COMM_WORLD, peer_comm, ierr )
     DO  i = 2, m_ncpl
        IF ( m_couplers(i)%parent_id == m_my_cpl_id )  THEN
 !
-!--       Identify all children models of the current model and create 
-!--       inter-communicators to connect between the current model and its 
-!--       children models.
+!--       Identify all children models of the current model and create inter-communicators to
+!--       connect between the current model and its children models.
           tag = 500 + i
-          CALL MPI_INTERCOMM_CREATE( comm, 0, peer_comm, start_pe(i),           &
-                                     tag, m_to_child_comm(i), istat)
+          CALL MPI_INTERCOMM_CREATE( comm, 0, peer_comm, start_pe(i), tag, m_to_child_comm(i),     &
+                                     istat )
           childcount = childcount + 1
           activeparent(i) = 1
        ELSEIF ( i == m_my_cpl_id)  THEN
 !
-!--       Create an inter-communicator to connect between the current 
-!--       model and its parent model.    
+!--       Create an inter-communicator to connect between the current model and its parent model.
           tag = 500 + i
-          CALL MPI_INTERCOMM_CREATE( comm, 0, peer_comm,                        &
-                                     start_pe(m_couplers(i)%parent_id),         &
-                                     tag, m_to_parent_comm, istat )
+          CALL MPI_INTERCOMM_CREATE( comm, 0, peer_comm, start_pe(m_couplers(i)%parent_id), tag,   &
+                                     m_to_parent_comm, istat )
        ENDIF
     ENDDO
 !
-!-- If I am a parent, count the number of children I have.
-!-- Although this loop is symmetric on all processes, the "activeparent" flag
-!-- is true (==1) on the respective individual process only.
+!-- If I am a parent, count the number of children I have. Although this loop is symmetric on all
+!-- processes, the "activeparent" flag is true (==1) on the respective individual process only.
     ALLOCATE( pmc_parent_for_child(childcount+1) )
 
@@ -311,6 +314,5 @@
 !-- Get the size of the parent model
     IF ( m_my_cpl_id > 1 )  THEN
-       CALL MPI_COMM_REMOTE_SIZE( m_to_parent_comm, m_parent_remote_size,       &
-                                  istat )
+       CALL MPI_COMM_REMOTE_SIZE( m_to_parent_comm, m_parent_remote_size, istat )
     ELSE
 !
@@ -319,10 +321,9 @@
     ENDIF
 !
-!-- Set myid to non-zero value except for the root domain. This is a setting
-!-- for the message routine which is called at the end of pmci_init. That
-!-- routine outputs messages for myid = 0, only. However, myid has not been
-!-- assigened so far, so that all processes of the root model would output a
-!-- message. To avoid this, set myid to some other value except for process 0 
-!-- of the root domain.
+!-- Set myid to non-zero value except for the root domain. This is a setting for the message routine
+!-- which is called at the end of pmci_init. That routine outputs messages for myid = 0, only.
+!-- However, myid has not been assigened so far, so that all processes of the root model would
+!-- output a message. To avoid this, set myid to some other value except for process 0 of the root
+!-- domain.
     IF ( m_world_rank /= 0 )  myid = 1
 
@@ -330,8 +331,11 @@
 
 
-
- SUBROUTINE pmc_get_model_info( comm_world_nesting, cpl_id, cpl_name,           &
-                                cpl_parent_id, lower_left_x, lower_left_y,      &
-                                ncpl, npe_total, request_for_cpl_id )
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @Todo: Missing subroutine description.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE pmc_get_model_info( comm_world_nesting, cpl_id, cpl_name, cpl_parent_id, lower_left_x, &
+                                lower_left_y, ncpl, npe_total, request_for_cpl_id )
 !
 !-- Provide module private variables of the pmc for PALM
@@ -407,23 +411,31 @@
 
 
- SUBROUTINE read_coupling_layout( nesting_datatransfer_mode, nesting_mode,      &
-      anterpolation_buffer_width, pmc_status )
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> @Todo: Missing subroutine description.
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE read_coupling_layout( nesting_datatransfer_mode, nesting_mode,                         &
+                                  anterpolation_buffer_width, pmc_status )
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=8), INTENT(INOUT) ::  nesting_mode
-    CHARACTER(LEN=7), INTENT(INOUT) ::  nesting_datatransfer_mode
-    
-    INTEGER, INTENT(INOUT)      ::  anterpolation_buffer_width     !< Boundary buffer width for anterpolation
-    INTEGER(iwp), INTENT(INOUT) ::  pmc_status
-    INTEGER(iwp)                ::  bad_llcorner
-    INTEGER(iwp)                ::  i
-    INTEGER(iwp)                ::  istat
-
-    TYPE(pmc_layout), DIMENSION(pmc_max_models) ::  domain_layouts
-
-    NAMELIST /nesting_parameters/  domain_layouts, nesting_datatransfer_mode,  &
-                                   nesting_mode, anterpolation_buffer_width
-    
+    CHARACTER(LEN=7), INTENT(INOUT) ::  nesting_datatransfer_mode  !<
+    CHARACTER(LEN=8), INTENT(INOUT) ::  nesting_mode               !<
+
+    INTEGER, INTENT(INOUT)      ::  anterpolation_buffer_width  !< Boundary buffer width for anterpolation
+    INTEGER(iwp), INTENT(INOUT) ::  pmc_status                  !<
+
+    INTEGER(iwp) ::  bad_llcorner  !<
+    INTEGER(iwp) ::  i             !<
+    INTEGER(iwp) ::  istat         !<
+
+    TYPE(pmc_layout), DIMENSION(pmc_max_models) ::  domain_layouts  !<
+
+    NAMELIST /nesting_parameters/  domain_layouts,                                                 &
+                                   nesting_datatransfer_mode,                                      &
+                                   nesting_mode,                                                   &
+                                   anterpolation_buffer_width
+
 !
 !-- Initialize some coupling variables
@@ -435,8 +447,8 @@
 !-- Open the NAMELIST-file and read the nesting layout
     CALL check_open( 11 )
-    READ ( 11, nesting_parameters, IOSTAT=istat )
-!
-!-- Set filepointer to the beginning of the file. Otherwise process 0 will later
-!-- be unable to read the inipar-NAMELIST
+    READ ( 11, nesting_parameters, IOSTAT = istat )
+!
+!-- Set filepointer to the beginning of the file. Otherwise process 0 will later be unable to read
+!-- the inipar-NAMELIST
     REWIND ( 11 )
 
@@ -473,10 +485,9 @@
     ENDDO
 !
-!-- Make sure that all domains have equal lower left corner in case of vertical
-!-- nesting
+!-- Make sure that all domains have equal lower left corner in case of vertical nesting
     IF ( nesting_mode == 'vertical' )  THEN
        bad_llcorner = 0
        DO  i = 1, m_ncpl
-          IF ( domain_layouts(i)%lower_left_x /= 0.0_wp .OR.                    &
+          IF ( domain_layouts(i)%lower_left_x /= 0.0_wp .OR.                                       &
                domain_layouts(i)%lower_left_y /= 0.0_wp )  THEN
              bad_llcorner = bad_llcorner + 1
@@ -486,7 +497,7 @@
        ENDDO
        IF ( bad_llcorner /= 0)  THEN
-          WRITE ( message_string, *)  'at least one dimension of lower ',       &
-                                      'left corner of one domain is not 0. ',   &
-                                      'All lower left corners were set to (0, 0)'
+          WRITE( message_string, *)  'at least one dimension of lower ',                           &
+                                     'left corner of one domain is not 0. ',                       &
+                                     'All lower left corners were set to (0, 0)'
           CALL message( 'read_coupling_layout', 'PA0427', 0, 0, 0, 6, 0 )
        ENDIF