Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 4651)
+++ palm/trunk/SOURCE/Makefile	(revision 4652)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# routine posix_calls_from_fortran merged into posix_interface_mod
+#
+# 4628 2020-07-29 07:23:03Z raasch
 # dependencies for particle data MPI-I/O added
 # 
@@ -284,5 +287,4 @@
 	poismg_mod.f90 \
 	poismg_noopt_mod.f90 \
-	posix_calls_from_fortran.f90 \
 	posix_interface_mod.f90 \
 	pres.f90 \
@@ -447,5 +449,5 @@
 	modules.o \
 	netcdf_interface_mod.o \
-	posix_calls_from_fortran.o
+	posix_interface_mod.o
 check_parameters.o: \
 	basic_constants_and_equations_mod.o \
@@ -999,6 +1001,4 @@
 	mod_kinds.o \
 	modules.o
-posix_calls_from_fortran.o: \
-
 posix_interface_mod.o: \
 	mod_kinds.o
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 4651)
+++ palm/trunk/SOURCE/check_open.f90	(revision 4652)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Routine fortran_sleep has been moved to module posix_interface
+! 
+! 4577 2020-06-25 09:53:58Z raasch
 ! further re-formatting to follow the PALM coding standard
 !
@@ -105,5 +108,5 @@
     USE pegrid
 
-    USE posix_calls_from_fortran,                                                                  &
+    USE posix_interface,                                                                           &
         ONLY:  fortran_sleep
 
Index: palm/trunk/SOURCE/posix_calls_from_fortran.f90
===================================================================
--- palm/trunk/SOURCE/posix_calls_from_fortran.f90	(revision 4651)
+++ 	(revision )
@@ -1,92 +1,0 @@
-!> @posix_calls_from_fortran.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2020 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-!
-! Current revisions:
-! -----------------
-!
-!
-! Former revisions:
-! -----------------
-! $Id: posix_calls_from_fortran.f90 2696 2017-12-14 17:12:51Z kanani $
-! File re-formatted to follow the PALM coding standard
-!
-!
-! 2696 2017-12-14 17:12:51Z kanani
-! Corrected "Former revisions" section
-!
-! 2696 2017-12-14 17:12:51Z kanani
-! Add variable description
-!
-! 1986 2016-08-10 14:07:17Z gronemeier
-! Initial revision
-!
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Collection of POSIX-command calls for Fortran
-!--------------------------------------------------------------------------------------------------!
- MODULE posix_calls_from_fortran
-
-    USE, INTRINSIC ::  iso_c_binding,                                                              &
-        ONLY: c_int
-
-    IMPLICIT none
-
-    PRIVATE
-
-
-    INTERFACE
-!
-!--    Sleep function from C library
-       FUNCTION fsleep( seconds )  BIND( C, NAME = 'sleep' )
-          IMPORT
-          INTEGER(c_int)                    ::  fsleep   !<
-          INTEGER(c_int), INTENT(IN), VALUE ::  seconds  !<
-       END FUNCTION fsleep
-
-    END INTERFACE
-
-    INTERFACE fortran_sleep
-       MODULE PROCEDURE fortran_sleep
-    END INTERFACE fortran_sleep
-
-    PUBLIC fortran_sleep
-
-
- CONTAINS
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Wait a specified amount of seconds
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE fortran_sleep( seconds )
-
-    INTEGER, INTENT(IN) ::  seconds             !< seconds to wait
-
-    INTEGER(c_int)      ::  seconds_in_c        !< same as seconds
-    INTEGER(c_int)      ::  sleep_return_value  !< returned value to sleep
-
-    seconds_in_c = seconds
-
-    sleep_return_value = fsleep( seconds_in_c )
-
- END SUBROUTINE fortran_sleep
-
- END MODULE posix_calls_from_fortran
Index: palm/trunk/SOURCE/posix_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/posix_interface_mod.f90	(revision 4651)
+++ palm/trunk/SOURCE/posix_interface_mod.f90	(revision 4652)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Routine fortran_sleep moved from old module posix_calls_from_fortran to here
+!
+! 4649 2020-08-25 12:11:17Z raasch
 ! File re-formatted to follow the PALM coding standard
 !
@@ -116,5 +119,19 @@
 
 !
+!-- Sleep function from C library
+    INTERFACE
+       FUNCTION fsleep( seconds )  BIND( C, NAME = 'sleep' )
+          IMPORT
+          INTEGER(C_INT)                    ::  fsleep   !<
+          INTEGER(C_INT), INTENT(IN), VALUE ::  seconds  !<
+       END FUNCTION fsleep
+    END INTERFACE
+
+!
 !-- PALM interfaces
+    INTERFACE fortran_sleep
+       MODULE PROCEDURE fortran_sleep
+    END INTERFACE fortran_sleep
+
     INTERFACE posix_close
        MODULE PROCEDURE posix_close
@@ -155,5 +172,6 @@
     END INTERFACE posix_write
 
-    PUBLIC posix_close,                                                                            &
+    PUBLIC fortran_sleep,                                                                          &
+           posix_close,                                                                            &
            posix_lseek,                                                                            &
            posix_open,                                                                             &
@@ -162,4 +180,23 @@
 
  CONTAINS
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Wait a specified amount of seconds
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE fortran_sleep( seconds )
+
+    INTEGER, INTENT(IN) ::  seconds             !< seconds to wait
+
+    INTEGER(C_INT)      ::  seconds_in_c        !< same as seconds
+    INTEGER(C_INT)      ::  sleep_return_value  !< returned value to sleep
+
+    seconds_in_c = seconds
+
+    sleep_return_value = fsleep( seconds_in_c )
+
+ END SUBROUTINE fortran_sleep
+
 
  INTEGER FUNCTION posix_open( file_name, rd_flag )