Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4630)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4653)
@@ -362,14 +362,9 @@
                force_radiation_call,                                                               &
                id,                                                                                 &
-               ieast_l,                                                                            &
-               ieast_u,                                                                            &
-               inorth_l,                                                                           &
-               inorth_u,                                                                           &
-               isouth_l,                                                                           &
-               isouth_u,                                                                           &
-               iup_l,                                                                              &
-               iup_u,                                                                              &
-               iwest_l,                                                                            &
-               iwest_u,                                                                            &
+               ieast,                                                                              &
+               inorth,                                                                             &
+               isouth,                                                                             &
+               iup,                                                                                &
+               iwest,                                                                              &
                nz_urban_b,                                                                         &
                nz_urban_t,                                                                         &
@@ -1343,5 +1338,5 @@
     INTEGER(iwp), PARAMETER                            ::  nd = 5                                  !< number of directions
     CHARACTER(LEN=6), DIMENSION(0:nd-1), PARAMETER     ::  dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
-    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         ::  dirint = (/ iup_u, isouth_u, inorth_u, iwest_u, ieast_u /)
+    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         ::  dirint = (/ iup, isouth, inorth, iwest, ieast /)
 
 
@@ -2460,5 +2455,5 @@
 
     INTEGER(iwp), PARAMETER                            ::  nd = 5  !< number of directions
-    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         ::  dirint =  (/    iup_u, isouth_u, inorth_u,  iwest_u,  ieast_u /)  !<
+    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         ::  dirint =  (/      iup,   isouth,   inorth,    iwest,    ieast /)  !<
     INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER         ::  diridx =  (/       -1,        1,        0,        3,        2 /)
                                                            !< index for surf_*_v: 0:3 = (North, South, East, West)
@@ -2531,5 +2526,5 @@
 !
 !--       Array of surface height (z)
-          IF ( idsint == iup_u )  THEN
+          IF ( idsint == iup )  THEN
              DO  m = 1, surf_usm_h%ns
                 i = surf_usm_h%i(m)
@@ -2551,5 +2546,5 @@
 !
 !--       Surface category
-          IF ( idsint == iup_u )  THEN
+          IF ( idsint == iup )  THEN
              DO  m = 1, surf_usm_h%ns
                 i = surf_usm_h%i(m)
@@ -2571,5 +2566,5 @@
 !
 !--       Transmissivity window tiles
-          IF ( idsint == iup_u )  THEN
+          IF ( idsint == iup )  THEN
              DO  m = 1, surf_usm_h%ns
                 i = surf_usm_h%i(m)
@@ -2592,5 +2587,5 @@
 !--       Array of sensible heat flux from surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2609,5 +2604,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2632,5 +2627,5 @@
 !--       Array of latent heat flux from surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2649,5 +2644,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2671,5 +2666,5 @@
 !--       Array of latent heat flux from vegetation surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2688,5 +2683,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2710,5 +2705,5 @@
 !--       Array of latent heat flux from surfaces with liquid
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2727,5 +2722,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2749,5 +2744,5 @@
 !--       Array of heat flux from ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2766,5 +2761,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2788,5 +2783,5 @@
 !--       Array of heat flux from window ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2805,5 +2800,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2827,5 +2822,5 @@
 !--       Array of heat flux from green ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2844,5 +2839,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2866,5 +2861,5 @@
 !--       Array of heat flux from indoor ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2883,5 +2878,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2905,5 +2900,5 @@
 !--       Array of heat flux from indoor window ground (land, wall, roof)
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2922,5 +2917,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2944,5 +2939,5 @@
 !--       Surface temperature for surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2961,5 +2956,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -2983,5 +2978,5 @@
 !--       Surface temperature for window surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3001,5 +2996,5 @@
 
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3025,5 +3020,5 @@
 !--       Surface temperature for green surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3043,5 +3038,5 @@
 
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3067,5 +3062,5 @@
 !--       Near surface temperature for whole surfaces
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3086,5 +3081,5 @@
 
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3109,5 +3104,5 @@
 !--       Wall temperature for  iwl layer of walls and land
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3126,5 +3121,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3148,5 +3143,5 @@
 !--       Window temperature for iwl layer of walls and land
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3165,5 +3160,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3187,5 +3182,5 @@
 !--       Green temperature for  iwl layer of walls and land
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3204,5 +3199,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3226,5 +3221,5 @@
 !--       Soil water content for  iwl layer of walls and land
           IF ( av == 0 )  THEN
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)
@@ -3237,5 +3232,5 @@
              ENDIF
           ELSE
-             IF ( idsint == iup_u )  THEN
+             IF ( idsint == iup )  THEN
                 DO  m = 1, surf_usm_h%ns
                    i = surf_usm_h%i(m)