Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4666)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4667)
@@ -23,5 +23,5 @@
 ! Current revisions:
 ! ------------------
-!
+! Improve debug messages during timestepping
 !
 ! Former revisions:
@@ -5884,5 +5884,8 @@
 #endif
 
-     IF ( debug_output_timestep )  CALL debug_message( 'radiation_interaction', 'start' )
+     IF ( debug_output_timestep )  THEN
+         WRITE( debug_string, * ) 'radiation_interaction', time_since_reference_point
+         CALL debug_message( debug_string, 'start' )
+     ENDIF
 
      IF ( plant_canopy )  THEN
Index: /palm/trunk/SOURCE/time_integration.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration.f90	(revision 4666)
+++ /palm/trunk/SOURCE/time_integration.f90	(revision 4667)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Improve debug messages during timestepping
 ! 
 ! Former revisions:
@@ -274,7 +274,8 @@
                averaging_interval, averaging_interval_pr, bc_lr_cyc, bc_ns_cyc, bc_pt_t_val,       &
                bc_q_t_val, biometeorology, call_psolver_at_all_substeps,  child_domain,            &
-               constant_flux_layer, constant_heatflux, create_disturbances,        &
+               constant_flux_layer, constant_heatflux, create_disturbances,                        &
                dopr_n, constant_diffusion, coupling_mode, coupling_start_time,                     &
-               current_timestep_number, disturbance_created, disturbance_energy_limit, dist_range, &
+               current_timestep_number, debug_output_timestep, debug_string,                       &
+               disturbance_created, disturbance_energy_limit, dist_range,                          &
                do_sum, dt_3d, dt_averaging_input, dt_averaging_input_pr, dt_coupling,              &
                dt_data_output_av, dt_disturb, dt_do2d_xy, dt_do2d_xz, dt_do2d_yz, dt_do3d,         &
@@ -646,4 +647,9 @@
 
        CALL cpu_log( log_point_s(10), 'timesteps', 'start' )
+
+       IF ( debug_output_timestep )  THEN
+           WRITE( debug_string, * ) 'time_integration', simulated_time
+           CALL debug_message( debug_string, 'start' )
+       ENDIF
 
 !
@@ -1688,4 +1694,9 @@
        IF ( myid == 0 )  CALL output_progress_bar
 
+       IF ( debug_output_timestep )  THEN
+           WRITE( debug_string, * ) 'time_integration', simulated_time
+           CALL debug_message( debug_string, 'end' )
+       ENDIF
+
        CALL cpu_log( log_point_s(10), 'timesteps', 'stop' )
 
Index: /palm/trunk/SOURCE/time_integration_spinup.f90
===================================================================
--- /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 4666)
+++ /palm/trunk/SOURCE/time_integration_spinup.f90	(revision 4667)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Improve debug messages during timestepping
 !
 ! Former revisions:
@@ -100,4 +100,6 @@
                coupling_start_time,                                                                &
                data_output_during_spinup,                                                          &
+               debug_output_timestep,                                                              &
+               debug_string,                                                                       &
                dopr_n,                                                                             &
                do_sum,                                                                             &
@@ -305,4 +307,9 @@
        CALL cpu_log( log_point_s(15), 'timesteps spinup', 'start' )
 
+       IF ( debug_output_timestep )  THEN
+           WRITE( debug_string, * ) 'time_integration_spinup', simulated_time
+           CALL debug_message( debug_string, 'start' )
+       ENDIF
+
 !
 !--    Start of intermediate step loop
@@ -606,4 +613,8 @@
        ENDIF
 
+       IF ( debug_output_timestep )  THEN
+           WRITE( debug_string, * ) 'time_integration_spinup', simulated_time
+           CALL debug_message( debug_string, 'end' )
+       ENDIF
 
 
Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4666)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4667)
@@ -22,5 +22,5 @@
 ! Current revisions:
 ! -----------------
-!
+! Limit vertical r_a similarly to horizontal
 !
 ! Former revisions:
@@ -8070,4 +8070,5 @@
 !--        Limit aerodynamic resistance
            IF ( surf_usm_v(l)%r_a(m) < 1.0_wp )  surf_usm_v(l)%r_a(m) = 1.0_wp
+           IF ( surf_usm_v(l)%r_a(m) > 300.0_wp )  surf_usm_v(l)%r_a(m) = 300.0_wp
 
            f_shf         = rho_cp / surf_usm_v(l)%r_a(m)